#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 20 18:24:17 2020

@author: cghiaus
Module MOODLE cloze questions generated by Python
"""


from itertools import product

# In <question>Ò
penalty = 0.3333           # for each tried answer

question_structure = """
\n  <question type="cloze">
\n    <name>
\n      <text>{question_name:s}</text>
\n    </name>
\n    <questiontext format="markdown">
\n      <text>
\n        <![CDATA[
\n          {text:s}
\n        ]]>
\n      </text>
\n     </questiontext>
\n    <generalfeedback format="html">
\n      <text></text>
\n    </generalfeedback>
\n    <penalty>{p:.3f}</penalty>
\n    <hidden>0</hidden>
\n    <idnumber></idnumber>
\n  </question>
"""


def cprod(dictionary):
    """Generate a list of dicts of cartesian product combinations."""
    return (dict(zip(dictionary, x)) for x
            in product(*dictionary.values()))


def generate_quiz(question_name, problem_fun, x_ranges, text):
    """
    Parameters
    ----------
    question_name : str
        Used for the .xml file and the 'Question name' in Moodle.
        In Moodle the number of the question is added (e.g. question_003)

    problem_fun : function
        DESCRIPTION.

    x_ranges : dict
        DESCRIPTION.

    text : str
        DESCRIPTION.

    Returns
    -------
    quiz : str
        Test of .xml file

    """
    question_number = 0
    questions = ""
    for x in cprod(x_ranges):
        question_text = text.format(**x, **problem_fun(x))
        question_name_number = question_name + '_'
        question_name_number += str(question_number).zfill(3)
        questions += question_structure.format(
            question_name=question_name_number,
            text=question_text,
            p=penalty)
        question_number += 1

    quiz = '<?xml version="1.0" encoding="UTF-8"?>' + '\n<quiz>'
    quiz += questions
    quiz += '\n</quiz>'

    xml_file_name = question_name + '.xml'
    with open(xml_file_name, 'w') as MOODLE_cloze:
        MOODLE_cloze.write(quiz)

    return quiz
